using System;

namespace ConsoleApp34
{
    class Program
    {
        static int Saberi(string[] s, int i, int j)
        {
            if (i == j)
                return 0;
            return Saberi(s, i + 1,j) + int.Parse(s[i]);
        }
        static void Main(string[] args)
        {
            string[] s = Console.ReadLine().Split();
            int n = int.Parse(s[0]);
            int k = int.Parse(s[1]); int p = 0;
            s = Console.ReadLine().Split();
            if (k == 0)
            {
                p = Saberi(s, 0, s.Length)%1000000007;
            }
            if (k==1)
            {
                for (int i = 0; i < n; i++)
                {
                    for (int j = i+1; j < n+1; j++)
                    {
                        p += Saberi(s, i, j) % 1000000007;
                    }
                }
            }
            Console.WriteLine(p);
        }
    }
}